
#ifdef __MSDOS__
#include "stdio.h"
#include "ctype.h"
#else 
#include "stdio51.h"
#endif

void flush_last(void);
void emit(void);
void parse(char c);
int match(char *in,char *comdlist[]);
void setpaper(int a,int b,int c,int d);
void setwindow(int a,int b,int c,int d);
void home(void);
void setspeed(int spd);
void setaccel(int start,int end,int ac);

#define UP 1
#define DOWN 0
#define ABSOLUTE 2
#define RELATIVE 4

int absX = 0;
int absY = 0;
int ZUp = 200;
int ZDown = -200;
int HomeX,HomeY;

char *comdlist[] = {
		"CA",
		"IP",
		"SC",
		"SP",
		"CS",
		"VS",
		"IW",
		"IN",
		"PA",
		"PR",
		"PU",
		"PD",
		"ZQ",		/* Acceleration tables */
		"ZP",		/* cutter position */
		"ZH",		/* offset origin   */
		0
		};
enum
	{
	UNKNOWN = -1,
	CA = 0,
	IP,
	SC,
	SP,
	CS,
	VS,
	IW,
	IN,
	PA,
	PR,
	PU,
	PD,
	ZQ,
	ZP,
	ZH,
	};

FILE *fout;
main()
{
	FILE *fin;
	int c;

	fin = fopen("test.hpg","rt");
	fout = fopen("test.out","wt");
	if(fout != NULL && fin != NULL) while(1 )
	{
		c = fgetc(fin);
		if( c == -1 ) break;
		parse(c);
	}
}
int comd;
int number;
int punct;
char numbuff[20];
char alphabuff[128];
int numbers[10];
int window[4],paper[4];
int numnum = 0;
int up_down;
int last_state = UP;
int abs_rel;
int pen_up;

void parse(char c)
{
	if(isdigit(c) || c == '-')
	{
		if(comd)
		{
			flush_last();
			comd = punct = 0;
		}
		numbuff[number++] = c;
		numbuff[number] = 0;
	}
	else if(ispunct(c) || c == '\x03')
	{
		flush_last();
		comd = number = 0;
		punct = 1;
	}
	else if(isalpha(c))
	{
		if(number)
		{
			flush_last();
			number = punct = 0;
		}
		alphabuff[comd++] = c;
		alphabuff[comd] = 0;
	}
}
int mat;
void flush_last(void)
{
	int n,i;
	char temp[80];

	if(number)
	{
		numbers[numnum] = atoi(numbuff);
#ifdef DEBUG
		fprintf(fout,"N[%d] = %d ",numnum,numbers[numnum]);
#endif
		numnum++;
	}
	switch(mat)
	{
		case UNKNOWN:
#ifdef DEBUG
			fprintf(fout,"Unknown %d \n",mat);
#endif
		break;
		case CA:
			if(numnum) fprintf(fout,"CA %d\n",numbers[0]);
			numnum = 0;
		break;
		case IP:
			if(numnum == 4)
			{
				setpaper(numbers[0],numbers[1],numbers[2],numbers[3]);
				numnum = 0;
			}
		break;
		case SP:
			if(numnum)
			{
				fprintf(fout,"SP %d\n",numbers[0]);
			}
			numnum = 0;
		break;
		case CS:
			numnum = 0;
		break;
		case VS:
			if(numnum)
			{
				setspeed(numbers[0]);
			}
			else setspeed(0);
			numnum = 0;
		break;
		case IW:
			if(numnum == 4)
			{
				setwindow(numbers[0],numbers[1],numbers[2],numbers[3]);
				numnum = 0;
			}
		break;
		case IN:
				numnum = 0;
		break;
		case PU:
		case PD:
		case PR:
		case PA:
			if(numnum == 2)
			{
				emit();
				numnum = 0;
			}
		break;
		case ZQ:
			if(numnum == 3)
			{
				setaccel(numbers[0],numbers[1],numbers[2]);
				numnum = 0;
			}
		break;
		case ZP:
			if(numnum == 2)
			{
				ZUp = 	numbers[0];
				ZDown = 	numbers[1];
				numnum = 0;
			}
		break;
		case ZH:
			if(numnum == 2)
			{
				HomeX = 	numbers[0];
				HomeY =	numbers[1];
				numnum = 0;
			}
		break;
	}
	if(comd)
	{
		while(comd)
		{
		strcpy(temp,alphabuff);
		temp[2] = 0;
		mat = match(alphabuff,comdlist);
#ifdef DEBUG
			fprintf(fout,"matched [%s][%s] = %d\n",(mat >= 0 ? comdlist[mat]:"No match"),temp,mat);
#endif
		switch(mat)
		{
		case UNKNOWN:
#ifdef DEBUG
			fprintf(fout,">UNK\n");
#endif
		break;
		case CA:
		break;
		case IP:
		break;
		case SP:
		break;
		case CS:
		break;
		case VS:
		break;
		case IW:
		break;
		case IN:
			  absX = absY = 0;
			  home();
			  abs_rel = ABSOLUTE;
			  up_down = UP;
			  pen_up = UP;
		break;

		case PU:
				  up_down = UP;
		break;
		case PD:
				  up_down = DOWN;
		break;
		case PR:
				  abs_rel = RELATIVE;
		break;
		case PA:
				  abs_rel = ABSOLUTE;
		break;
		}
	}
	}
}

void emit(void)
{
	if(up_down == UP && last_state == DOWN)
	{
		fprintf(fout,"Z %d\n",ZUp);
		last_state = UP;
	}
	if(up_down == DOWN && last_state == UP)
	{
		fprintf(fout,"Z %d\n",ZDown);
		last_state = DOWN;
	}
	if(abs_rel == ABSOLUTE)
	{
		absX = numbers[0];
		absY = numbers[1];
		fprintf(fout,"M %d %d\n",absX,absY);
	}
	if(abs_rel == RELATIVE)
	{
		absX += numbers[0];
		absY += numbers[1];
		fprintf(fout,"M %d %d\n",absX,absY);
	}
}
int match(char *in,char *comdlist[])
{
	int i,rv,j;
	rv = -1;
	for(i = 0; comdlist[i] != NULL; i++)
	{
		if(strncmp(in,comdlist[i],2) == 0)
		{
			rv = i;
			movmem(alphabuff+2,alphabuff,sizeof(alphabuff)-2);
			comd -= 2;
			if(comd < 0) comd = 0;
			break;
		}
	}
	return(rv);
}
void home(void)
{
	fprintf(fout,"HOME\n");
}
void setwindow(int a,int b,int c,int d)
{
	fprintf(fout,"SETWINDOW %d %d %d %d\n",a,b,c,d);
}
void setpaper(int a,int b,int c,int d)
{
	fprintf(fout,"SETPAPER %d %d %d %d\n",a,b,c,d);
}
void setspeed(int spd)
{
	fprintf(fout,"SETSPEED %d\n",spd);
}
void setaccel(int start,int end,int ac)
{
	fprintf(fout,"SETACC %d %d %d\n",start,end,ac);
}
